set degPerMin [expr 1.0 / 60.0]
set degPerSec [expr 1.0 / 36000.0]

# Load weather stations
puts "Loading weather stations"
set count 0 
set stns [open nsd_cccc.txt r]
while {[gets $stns line] >= 0} { 
  set elems [split $line {;}]
  set country [lindex $elems 5]
  set stnId [lindex $elems 0]
  set name [lindex $elems 3]
  set state [lindex $elems 4]
  set elev [lindex $elems 11]
  regexp {([0-9][0-9])-([0-9][0-9])-?([0-9][0-9])?([NS])} \
    [lindex $elems 7] match deg min sec ns
  set lat [expr ($deg.0 + $min.0 * $degPerMin + $sec.0 * $degPerSec) \
    * [expr {($ns == "N") ? 1.0 : -1.0}]] 
  regexp {([01][0-9][0-9])-([0-9][0-9])-?([0-9][0-9])?([EW])} \
    [lindex $elems 8] match deg min sec ew
  set lon [expr ($deg.0 + $min.0 * $degPerMin + $sec.0 * $degPerSec) \
    * [expr {($ew == "E") ? 1.0 : -1.0}]] 
  geoplace set $stnId "$lat $lon"
  set descr($stnId) "$stnId: $name, $state $country, \
    [format "%.1f$ns %.1f$ew" [expr abs($lat)] [expr abs($lon)]], ${elev}m"
  incr count
}
puts "Found $count stations"
close $stns
